{
 -- Podstawowy kurs Turbo Pascal'a 7.0 --
 Copyright(c)by Jan T. Biernat
==========================================

 Program: Przypominacz - przypomina o waznych datach
}
uses Crt, Dos;

function FileExists(txtFileName :String) :Boolean;
var
  Info :SearchRec;
begin
  { FileExists }
  FindFirst(txtFileName, Directory, Info);
  FileExists:= FALSE;
  if (DosError = 0) then FileExists:= TRUE;
end;

function IntToStr(X :Longint) :String;
var
  txtText :String;
begin
  { IntToStr }
  STR(X, txtText);
  IntToStr:= txtText;
end;

function StrToInt(txtStr :String) :Longint;
var
   numNumber :Longint;
  numErrCode :Integer;
begin
  { StrToInt }
  VAL(txtStr, numNumber, numErrCode);
  StrToInt:= numNumber;
end;

function DodajZeroPrzed(txtStr :String) :String;
begin
  { DodajZeroPrzed }
  DodajZeroPrzed:= txtStr;
  if (Length(txtStr) = 1) then DodajZeroPrzed:= '0'+txtStr;
end;

function DATA_DzisJest :String;
var
  YE, M, D, DOW :Word;
begin
  GetDate(YE, M, D, DOW);
  DATA_DzisJest:= IntToStr(YE)+'-'+
            DodajZeroPrzed(IntToStr(M))+'-'+
            DodajZeroPrzed(IntToStr(D));
end;

function DATA_DzisJestDzien :String;
const
  DzienTygodnia :array [0..6] of String = ('Niedziela',
                                           'Poniedzialek',
                                           'Wtorek',
                                           'Sroda',
                                           'Czwartek',
                                           'Piatek',
                                           'Sobota');
var
  YE, M, D, DOW :Word;
begin
  GetDate(YE, M, D, DOW);
  DATA_DzisJestDzien:= DzienTygodnia[DOW];
end;

function DATA_MiesiacMaDni(txtDate :String) :Shortint;
var
  numMonth, numMonthToDays :Shortint;
                   numYear :Integer;
begin
  { DATA_MiesiacMaDni }
  numYear:= 0;
  numYear:= StrToInt(Copy(txtDate, 1, 4));

  numMonth:= 0;
  numMonth:= StrToInt(Copy(txtDate, 6, 2));

  numMonthToDays:= 0;
  if (numMonth in [1, 3, 5, 7, 8, 10, 12]) then numMonthToDays:= 31;
  if (numMonth in [4, 6, 9, 11]) then numMonthToDays:= 30;
  if (numMonth = 2) then
  begin
    numMonthToDays:= 28;
    if ((numYear mod 4 = 0) and (numYear mod 100 <>0)) or
       (numYear mod 400 = 0) then
    begin
      numMonthToDays:= 0;
      numMonthToDays:= 29;
    end;
  end;
  DATA_MiesiacMaDni:= numMonthToDays;
end;

function jtbPrzypominacz(txtDataMD :String) :Boolean;
var
  txtRMiesiac, txtRDzien, txtNazwaDnia :String;
                  txtMiesiac, txtDzien :String;
                           numIloscDni :Shortint;
begin
  { jtbPrzypominacz }
  jtbPrzypominacz:= FALSE;

    txtRMiesiac:= '';
    txtRMiesiac:= Copy(DATA_DzisJest, 6, 2);

    txtRDzien:= '';
    txtRDzien:= Copy(DATA_DzisJest, 9, 2);

    txtNazwaDnia:= '';
    txtNazwaDnia:= Copy(DATA_DzisJestDzien , 1, 2);

    numIloscDni:= 0;
    numIloscDni:= DATA_MiesiacMaDni(DATA_DzisJest);

  if (txtDataMD<>'') then
  begin

    txtMiesiac:= '';
    txtMiesiac:= DodajZeroPrzed(Copy(txtDataMD, 1, 2));

    txtDzien:= '';
    txtDzien:= DodajZeroPrzed(Copy(txtDataMD, 4, 2));
    if (txtDzien = '!!') then
    begin
      txtDzien:= '';
      txtDzien:= IntToStr(numIloscDni);
    end;

    if (txtMiesiac+'-'+txtDzien = txtRMiesiac+'-'+txtRDzien) or
       (txtMiesiac+'-'+txtDzien = txtRMiesiac+'---') or
       (txtMiesiac+'-'+txtDzien = '---'+txtRDzien) or
       (txtMiesiac+'-'+txtDzien = txtRMiesiac+'-'+txtNazwaDnia) or
       (txtMiesiac+'-'+txtDzien = '---'+txtNazwaDnia) or
       (txtMiesiac+'-'+txtDzien = '-----') then jtbPrzypominacz:= TRUE;
  end;
end;

procedure OdczytajPlik;
const
  txtNazwaPliku = 'reminder.txt';
var
  txtCzytaj :String;
         FT :Text;
         TT :Longint;
     okJest :Boolean;
begin
  { Przypominacz }
  if (FileExists(txtNazwaPliku) = TRUE) then
  begin
    Assign(FT, txtNazwaPliku);
    Reset(FT);
    TT:= 0;
    while not EOF(FT) do
    begin
      txtCzytaj:= '';
      ReadLn(FT, txtCzytaj);

      okJest:= FALSE;
      okJest:= jtbPrzypominacz(Copy(txtCzytaj, 1, 5));
      if (okJest = TRUE) then
      begin
        Writeln(IntToStr(TT+1)+')'+CHR(32)+
                Copy(DATA_DzisJest, 6, 5)+CHR(32)+
                Copy(txtCzytaj, 7, 77));
        TT:= TT+1;
      end;
    end;
    Close(FT)
  end;

  { Nacisnij dowolny klawisz... }
  Writeln;
  if (TT >0) then
  begin
    Write('Nacisnij dowolny klawisz...');
    repeat
    until KeyPressed;
  end;
end;



begin
  Writeln;
  Writeln('== Przypominacz ==');
  Writeln('Copyright(c)by Jan-Tadeusz Biernat');
  Writeln;
  Writeln('Dzisiaj jest:'+CHR(32)+DATA_DzisJest);
  Writeln('Dzien:'+CHR(32)+DATA_DzisJestDzien);
  Writeln;
  OdczytajPlik;
end.