{
 Plik: cw37z2

 == Slownie ==
 Copyright(c)by Jan Tadeusz Biernat
}

function StrToInt(txtStr :String) :Longint;
var
  numNumber, numErrCode :Integer;
begin
  { StrToInt }
  Val(txtStr, numNumber, numErrCode);
  StrToInt:= numNumber;
end;

function IntToStr(numNumer :Longint) :String;
var
   txtText: String;
begin
   txtText:= '';
   STR(numNumer, txtText);
   IntToStr:= txtText;
end;

function NUM_LikwidujSpacje(txtStr :String) :String;
var
        TT :Integer;
   txtText :String;
begin
   NUM_LikwidujSpacje:= '';
   if (txtStr<>'') then
   begin
      txtText:= '';
      for TT:= 1 to Length(txtStr) do
         if (txtStr[TT]<>CHR(32)) then
            txtText:= txtText+txtStr[TT];
      NUM_LikwidujSpacje:= txtText;
   end;
end;

function DodajZeroPrzed(txtZero :String) :String;
begin
   DodajZeroPrzed:= txtZero;
   if (Length(txtZero) = 1) then DodajZeroPrzed:= '0'+txtZero;
end;

function ZmienPrzecinekNaKropke(txtStr :String) :String;
var
   txtTekst :String;
     numPoz :Shortint;
begin
   ZmienPrzecinekNaKropke:= txtStr;
   if (txtStr<>'') then
   begin
      numPoz:= 0;
      numPoz:= Pos(',', txtStr);
      if (numPoz<>0) then
      begin
         txtTekst:= '';
         txtTekst:= Copy(txtStr, 1, numPoz-1)+'.'+
                    Copy(txtStr, numPoz+1, Length(txtStr));
         ZmienPrzecinekNaKropke:= txtTekst;
      end;
   end;
end;

function NUM_PobierzTylkoLiczby(txtStr :String; chrPrzecinek :Char) :String;
var
   txtCyfry :String;
         AA :Integer;
begin
   NUM_PobierzTylkoLiczby:= '0';
   if (txtStr<>'') then
   begin
      txtCyfry:= '';
      for AA:= 0 to Length(txtStr) do
        if (txtStr[AA] in ['0'..'9', chrPrzecinek]) then
           txtCyfry:= txtCyfry+txtStr[AA];
      NUM_PobierzTylkoLiczby:= txtCyfry;
      if (txtStr[1] ='-') then NUM_PobierzTylkoLiczby:= '-'+txtCyfry;
   end;
end;

function txtSlownieGramatyka(txtNumer :String; numPoz, numGrosz :Shortint) :String;
const
   MM: array[1..9, 1..4] of String[20] =
    (('sto ',         'dziesiec ',         'jeden ',    'jedenascie '),
     ('dwiescie ',    'dwadziescia ',      'dwa ',      'dwanascie '),
     ('trzysta ',     'trzydziesci ',      'trzy ',     'trzynascie '),
     ('czterysta ',   'czterdziesci ',     'cztery ',   'czternascie '),
     ('piecset ',     'piecdziesiat ',     'piec ',     'pitnascie '),
     ('szescset ',    'szescdziesiat ',    'szesc ',    'szesnascie '),
     ('siedemset ',   'siedemdziesiat ',   'siedem ',   'siedemnascie '),
     ('osiemset ',    'osiemdziesiat ',    'osiem ',    'osiemnascie '),
     ('dziewiecset ', 'dziewiecdziesiat ', 'dziewiec ', 'dziewietnascie '));

   NN: array[1..5, 1..3] of String[11] =
     (('zloty ',   'zlote ',    'zlotych '),
      ('tysiac ',  'tysiace ',  'tysiecy '),
      ('milion ',  'miliony ',  'milionow '),
      ('miliard ', 'miliardy ', 'miliardow '),
      ('bilion ',  'biliony ',  'bilionow '));

   PP: array [1..3] of String[7] = ('grosz', 'grosze', 'groszy');
var
   TT, JJ, numTPos: Shortint;
           txtSlow: String;
begin
   { txtSlownieGramatyka }
   txtSlownieGramatyka:= '';

   if (numPoz < 1) then numPoz:= 1;
   if (Length(txtNumer) = 1) then txtNumer:= '00'+txtNumer;
   if (Length(txtNumer) = 2) then txtNumer:= '0'+txtNumer;

   txtSlow:= '';
   if (Length(txtNumer) = 3) then
   begin
      if (StrToInt(Copy(txtNumer, 2, 2)) in [11..19]) and
         (StrToInt(Copy(txtNumer, 1, 1)) = 0) then
      begin
         txtSlownieGramatyka:= MM[StrToInt(Copy(txtNumer, 2, 2))-10, 4]+NN[numPoz, 3];
         if (numGrosz >0) then
            txtSlownieGramatyka:= MM[StrToInt(Copy(txtNumer, 2, 2))-10, 4]+PP[3];
      end
      else
      if (StrToInt(Copy(txtNumer, 2, 2)) in [11..19]) and
         (StrToInt(Copy(txtNumer, 1, 1)) > 0) then
      begin
         txtSlow:= '';
         txtSlow:= MM[StrToInt(Copy(txtNumer, 2, 2))-10, 4]+NN[numPoz, 3];
         if (numGrosz >0) then
            txtSlow:= MM[StrToInt(Copy(txtNumer, 2, 2))-10, 4]+PP[3];
         txtSlownieGramatyka:= MM[StrToInt(Copy(txtNumer, 1, 1)), 1]+txtSlow;
      end
      else
      begin
         txtSlow:= '';
         for TT:= 1 to Length(txtNumer) do
            for JJ:= 1 to 9 do
               if (Copy(txtNumer, TT, 1) = IntToStr(JJ)) then txtSlow:= txtSlow+MM[JJ, TT];
         numTPos:= 0;
         numTPos:= 1;
         if (StrToInt(Copy(txtNumer, 3, 1)) in [2..4]) then numTPos:= 2;
         if (StrToInt(Copy(txtNumer, 3, 1)) in [5..9]) or
            (StrToInt(Copy(txtNumer, 2, 1)) in [2..9]) and
            (StrToInt(Copy(txtNumer, 3, 1)) =1) or
            (StrToInt(Copy(txtNumer, 1, 1)) in [1..9]) and
            (StrToInt(Copy(txtNumer, 2, 1)) = 0) and
            (StrToInt(Copy(txtNumer, 3, 1)) = 1) or
            (StrToInt(Copy(txtNumer, 2, 1)) in [1..9]) and
            (StrToInt(Copy(txtNumer, 3, 1)) = 0) or
            (StrToInt(Copy(txtNumer, 1, 1)) in [1..9]) and
            (Copy(txtNumer, 2, 2) = '00') then
         begin
            numTPos:= 0;
            numTPos:= 3;
         end;
         txtSlownieGramatyka:= txtSlow+NN[numPoz, numTPos];
         if (numGrosz >0) then txtSlownieGramatyka:= txtSlow+PP[numTPos];
         if (Copy(txtNumer, 1, 3) = '000') then txtSlownieGramatyka:= '';
      end;
   end;
end;

function txtSlowniePisz(txtNumer, txtGrosz :String) :String;
var
   txtSlo, txtSGrosz :String;
                  TT :Shortint;
begin
   { txtSlowniePisz }
   txtSlowniePisz:= '';
   txtSGrosz:= '';
   txtSGrosz:= 'i zero groszy';
   if (StrToInt(txtGrosz) >0) then
   begin
      txtSGrosz:= '';
      txtSGrosz:= 'i '+txtSlownieGramatyka(DodajZeroPrzed(txtGrosz), 1, 1);
   end;


   for TT:= 1 to 15-Length(txtNumer) do
      txtNumer:= '0'+txtNumer;

   txtSlo:= '';
   txtSlo:= txtSlownieGramatyka(Copy(txtNumer, 1, 3), 5, 0)+
            txtSlownieGramatyka(Copy(txtNumer, 4, 3), 4, 0)+
            txtSlownieGramatyka(Copy(txtNumer, 7, 3), 3, 0)+
            txtSlownieGramatyka(Copy(txtNumer, 10, 3), 2, 0)+
            txtSlownieGramatyka(Copy(txtNumer, 13, 3), 1, 0);

   if (txtSlo = '') then
   begin
     txtSlo:= '';
     txtSlo:= 'zero zlotych'+CHR(32);
   end;

   txtSlowniePisz:= txtSlo+txtSGrosz;
end;

function txtSlowniePLN(txtNumer :String) :String;
var
                      numPoz: Shortint;
   txtSpacja, txtPrzecinek, txtCyfra,
   txtCyfraPrzed, txtCyfraPo: String;
begin
   { txtSlowniePLN }
   txtSpacja:= '';
   txtSpacja:= NUM_LikwidujSpacje(txtNumer);


   txtPrzecinek:= '';
   txtPrzecinek:= ZmienPrzecinekNaKropke(txtSpacja);


   txtCyfra:= '';
   txtCyfra:= NUM_PobierzTylkoLiczby(txtPrzecinek, '.');


   numPoz:= 0;
   numPoz:= Pos('.', txtCyfra);
   if (numPoz<>0) then
   begin
      txtCyfraPo:= '';
      txtCyfraPo:= DodajZeroPrzed(Copy(txtCyfra, numPoz+1, 2));

      txtCyfraPrzed:= '';
      txtCyfraPrzed:= Copy(txtCyfra, 1, numPoz-1);

      txtSlowniePLN:= txtSlowniePisz(txtCyfraPrzed, txtCyfraPo);
   end
   else
      txtSlowniePLN:= txtSlowniePisz(txtCyfra, '-1');
end;
