{
 -- Podstawowy kurs Turbo Pascal'a 7.0 --
 Copyright(c)by Jan T. Biernat
==========================================

 Program: Pliki - Wykrywanie, Usuwanie, Zmiana nazwy
}
uses Crt, Dos;

function FileExists(txtFileName :String) :Boolean;
var
  Info :SearchRec;
begin
  { FileExists }
  FindFirst(txtFileName, Directory, Info);
  FileExists:= FALSE;
  if (DosError = 0) then FileExists:= TRUE;
end;

function DeleteFile(txtFileName :String) :Boolean;
var
  TF :Text;
begin
  { DeleteFile }
  DeleteFile:= FALSE;
  if (FileExists(txtFileName) = TRUE) then
  begin
    Assign(TF, txtFileName);
    SetFAttr(TF, Archive); { For Windows: faArchive }
    Erase(TF);
    DeleteFile:= TRUE;
  end;
end;

function RenameFile(txtFileNameOLD, txtFileNameNEW :String) :Boolean;
var
  TF :Text;
begin
  { RenameFile }
  RenameFile:= FALSE;
  if (FileExists(txtFileNameNEW) = FALSE) then
  begin
    if (FileExists(txtFileNameOLD) =TRUE) then
    begin
      Assign(TF, txtFileNameOLD);
      Rename(TF, txtFileNameNEW);
      SetFAttr(TF, Archive+ReadOnly); { For Windows: faArchive }
      RenameFile:= TRUE;
    end;
  end;
end;



var
  okPlik :Boolean;
begin
  ClrScr;
  Writeln;
  Writeln('== Pliki - Wykrywanie, Usuwanie, Zmiana nazwy ==');
  Writeln;

  Write('Zmiana nazwy pliku: ');
  okPlik:= RenameFile('plik.txt', 'pas.txt');
  if (okPlik = TRUE) then
    Write('Nazwa pliku zostala zmieniona.')
  else
    Write('Brak pliku o podanej nazwie!');


  Writeln;
  Write('Usuwanie pliku: ');
  okPlik:= DeleteFile('pas.txt');
  if (okPlik = TRUE) then
    Write('Plik zostal usuniety.')
  else
    Write('Brak pliku o podanej nazwie!');
end.