{
 -- Podstawowy kurs Turbo Pascal'a 7.0 --
 Copyright(c)by Jan T. Biernat
==========================================

 Program: Tabliczka Mnozenia
}
uses Crt;

procedure KT_KursorTekst(X, Y, TS :Shortint; txtStr :String);
var
      TT :Shortint;
  txtSpc :String;
begin
  { KT_KursorTekst }
  txtSpc:= '';
  for TT:= 0 to TS do
    txtSpc:= txtSpc+CHR(32);

  TextBackGround(BLACK);
  GotoXY(X, Y);
  Write(txtSpc);
  TextColor(WHITE);
  GotoXY(X, Y);
  Write(txtStr);
end;

function KN_KlawiszNacisnij :Integer;
var
  numKey :Integer;
      Ch :Char;
begin
  { KN_KlawiszNacisnij }
  repeat until KeyPressed;
    Ch:= ReadKey;
    numKey:= Ord(Ch);
    if (Ch =#0) then
    begin
      Ch:= ReadKey; { trap function keys }
      numKey:= Ord(Ch)+300;
    end;
  KN_KlawiszNacisnij:= numKEY;
end;


function Klawisze(X, Y, TS :Shortint; txtStr :String) :String;
var
  txtTekst :String;
    numKey :Integer;
begin
  { Klawisze }
  TextBackGround(BLACK);
  TextColor(WHITE);
  GotoXY(X, Y);
  Write(txtStr+':');
  txtTekst:= '';
  repeat
    KT_KursorTekst(X+Length(txtStr)+1, Y, TS, txtTekst);
    numKey:= 0;
    numKey:= KN_KlawiszNacisnij;
    if (numKey = 8) then
    begin
      txtTekst:= Copy(txtTekst, 1, Length(txtTekst)-1);
    end
    else
    if (numKey = 27) then
    begin
      Klawisze:= '';
    end
    else
    if (numKey = 13) then
    begin
      Klawisze:= txtTekst;
    end
    else
    begin
      if (Length(txtTekst) < TS) then
      begin
        if ((numKey > 47) and (numKey < 58)) then
          txtTekst:= txtTekst+CHR(numKey);
      end;
    end;
  until (numKey = 27) or (numKey = 13);
  TextBackGround(BLACK);
  TextColor(LightGRAY);
end;

procedure MT_Cyfry(X, Y, Cyfra :Shortint);
const
  txtCyfry1 :array[0..10] of String = (
    '   ####        ##        ###       ####          ##  ',
    '  ######   ######      #######  #########       ###  ',
    ' ##    ##  ##  ##     ##     ## ##     ##      ####  ',
    '##      ##     ##     ##      #        ##     ## ##  ',
    '##      ##     ##            ##     #####    ##  ##  ',
    '##      ##     ##          ###      #####   ##   ##  ',
    '##      ##     ##         ##           ### ##    ##  ',
    '##      ##     ##       ###             ## ######### ',
    ' ##    ##      ##      ##       #      ###       ##  ',
    '  ######   ########## ######### #########      ##### ',
    '   ####    ########## #########    ####        ##### ');

  txtCyfry2 :array[0..10] of String = (
    ' #######        #### #########    ####     ####    ',
    ' #######     ####### #########  ########  #######  ',
    ' #          ###      #      ## ##     ## ##     ## ',
    ' #         ##               ## ##      # #      ## ',
    ' ########  ## ####         ##   ##   ### ##     ## ',
    ' #     ##  #########       ##   #######  ###  #### ',
    '        ## ###    ##      ##   ###    ##   ##### # ',
    '        ## ##      #      ##   ##      #        ## ',
    '##     ### ##     ##     ##    ##     ##       ##  ',
    '#########   #######      ##     #######  #######   ',
    '   ####       ####       #        ####    ####     ');
var
  numKol :Shortint;
      TT :Shortint;
begin
  { MT_Cyfry }
  TextColor(LightBLUE);
  for TT:= 0 to 10 do
  begin
    if (Cyfra = 0) or (Cyfra = 5) then numKol:= 1;
    if (Cyfra = 1) or (Cyfra = 6) then numKol:= 11;
    if (Cyfra = 2) then numKol:= 22;
    if (Cyfra = 3) then numKol:= 33;
    if (Cyfra = 4) then numKol:= 43;
    if (Cyfra = 7) then numKol:= 21;
    if (Cyfra = 8) then numKol:= 31;
    if (Cyfra = 9) then numKol:= 42;
    GotoXY(X, Y+TT);
    if ((Cyfra >-1) and (Cyfra < 5)) then
       Write(Copy(txtCyfry1[TT], numKol, 11))
    else
    if ((Cyfra >4) and (Cyfra < 10)) then
       Write(Copy(txtCyfry2[TT], numKol, 11));
  end;
end;

procedure MT_ZnakRazy(X, Y: Shortint);
const
  txtRazy :array[0..7] of String = (
     '#####  #### ',
     '#####  #### ',
     '  ###  ##   ',
     '    ####    ',
     '   #####    ',
     '  ##   ###  ',
     '#####  #####',
     '#####  #####');
var
  TT :Shortint;
begin
  { MT_ZnakRazy }
  TextColor(LightBLUE);
  for TT:= 0 to 7 do
  begin
    GotoXY(X, Y+TT);
    Write(txtRazy[TT]);
  end;
end;

function IntToStr(X :Longint) :String;
var
  txtText :String;
begin
  { IntToStr }
  STR(X, txtText);
  IntToStr:= txtText;
end;

function StrToInt(txtStr :String) :Longint;
var
   numNumber :Longint;
  numErrCode :Integer;
begin
  { StrToInt }
  VAL(txtStr, numNumber, numErrCode);
  StrToInt:= numNumber;
end;

function fSpc(numSpc :Shortint) :String;
var
    TT :Shortint;
  txtS :String;
begin
  { fSpc }
  txtS:= '';
  for TT:= 0 to numSpc-1 do
    txtS:= txtS+CHR(32);
  fSpc:= txtS;
end;



var
  numLicz1, numLicz2, numWynik, TT :Shortint;
               txtLiczba, txtWynik :String;
begin
  TextBackGround(BLACK);
  TextColor(LightGRAY);
  ClrScr;
  Writeln('Tabliczka Mnozenia (c)by Jan-Tadeusz Biernat');
  repeat
    Randomize;
    numLicz1:= 0;
    numLicz1:= Random(10);

    numLicz2:= 0;
    numLicz2:= Random(10);

    numWynik:= 0;
    numWynik:= numLicz1*numLicz2;

    if (numLicz1 > 9) then
    begin
      txtLiczba:= '';
      txtLiczba:= IntToStr(numLicz1);
      MT_Cyfry(5, 5, StrToInt(Copy(txtLiczba, 1, 1)));
      MT_Cyfry(15, 5, StrToInt(Copy(txtLiczba, 2, 1)));
    end
    else
    begin
      MT_Cyfry(15, 5, numLicz1);
    end;

    MT_ZnakRazy(32, 8);

    if (numLicz2 > 9) then
    begin
      txtLiczba:= '';
      txtLiczba:= IntToStr(numLicz2);
      MT_Cyfry(48, 5, StrToInt(Copy(txtLiczba, 1, 1)));
      MT_Cyfry(59, 5, StrToInt(Copy(txtLiczba, 2, 1)));
    end
    else
    begin
      MT_Cyfry(48, 5, numLicz2);
    end;

    txtWynik:= '';
    txtWynik:= Klawisze(25, 19, 3, 'Twoja odpowiedz');

    if (txtWynik<>'') then
    begin
      GotoXY(47, 20);
      if (StrToInt(txtWynik) = numWynik) then
        Write('Bardzo dobrze!')
      else
        Write('Zle!');
      Delay(999);
      GotoXY(47, 20);
      Write(fSpc(14));
    end;

    { CLS }
    for TT:= 0 to 15 do
    begin
      GotoXY(4, 4+TT);
      Write(fSpc(67));
    end;
  until (txtWynik = '');
  TextBackGround(BLACK);
  TextColor(LightGRAY);
  ClrScr;
  Writeln('Pa pa');
end.